Subject: Re: [PATCH] powerpc: Fix stackprotector detection for non-glibc toolchains

From: Segher Boessenkool <[email-masked]>
Date: Sat, 13 Oct 2018 10:48:30 -0500

On Sat, Oct 13, 2018 at 10:55:01PM +1100, Michael Ellerman wrote:
> So it's only my cross compilers that don't work.
> 
> The kernel.org ones are:
>   Configured with: /home/arnd/git/gcc/configure --target=powerpc64-linux
>   --enable-targets=all
>   --prefix=/home/arnd/cross/x86_64/gcc-8.1.0-nolibc/powerpc64-linux
>   --enable-languages=c --without-headers --disable-bootstrap
>   --disable-nls --disable-threads --disable-shared --disable-libmudflap
>   --disable-libssp --disable-libgomp --disable-decimal-float
>   --disable-libquadmath --disable-libatomic --disable-libcc1
>   --disable-libmpx --enable-checking=release
> 
> Whereas mine is:
>   Configured with: ../../src/gcc/configure
>   --prefix=/home/kerkins/workspace/gcc-build/gcc/gcc-8-branch/target/ppc/build/install/powerpc-linux
>   --disable-multilib --disable-bootstrap --enable-languages=c
>   --with-pkgversion='Custom 2c79ff811dfcee1c' --target=powerpc-linux
>   --enable-targets=all
> 
> 
> So I wonder if something in there is making the difference?

You have --disable-libssp on the buildall-built compiler, which makes GCC
assume your libc has the SSP support routines, which gives you these default
offsets (which are what they are on glibc).  Never mind that you explicitly
do not have a libc ;-)

> I guess I'll just rewrite the change log to say "some toolchains".

Or "most".

Segher